"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:llvm_s' }"

"{ NameSpace: Smalltalk }"

LLVMDisposableObject subclass:#LLVMBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'LLVM-S-Core'
!

!LLVMBuilder class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!LLVMBuilder class methodsFor:'instance creation'!

new
    ^ LLVM CreateBuilder

    "Created: / 07-07-2015 / 22:38:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder class methodsFor:'generators'!

instructions
    ^ #(
        add:to: (isIntegerOrVector isIntegerOrVector)
        lsrh:by: (isIntegerOrVector isIntegerOrVector)
    )

    "Created: / 11-07-2015 / 13:05:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'initialization & release'!

dispose
    ^ LLVM DisposeBuilder: self.

    "Modified (comment): / 08-07-2015 / 22:39:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'instructions - binary'!

add:value1 and:value2 
    ^ self add:value1 and:value2 as:''

    "Created: / 07-07-2015 / 22:52:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (format): / 11-07-2015 / 13:00:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

add:value1 and:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value1 isIntegerOrVectorValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: (value2 isIntegerOrVectorValue).
    self assert: (name isSingleByteString).
    ^LLVM BuildAdd: self  _: value1 _: value2 _: name

    "Created: / 07-07-2015 / 22:52:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 11-07-2015 / 14:57:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

and:value1 and:value2 
    ^ self and:value1 and:value2 as:''

    "Created: / 11-07-2015 / 14:58:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

and:value1 and:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value1 isIntegerOrVectorValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: (value2 isIntegerOrVectorValue).
    self assert: (name isSingleByteString).
    ^LLVM BuildAnd: self  _: value1 _: value2 _: name

    "Created: / 11-07-2015 / 14:58:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ashr:value1 by:value2 
    ^ self ashr:value1 by: value2 as:''

    "Created: / 11-07-2015 / 16:46:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ashr:value1 by:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value1 isIntegerOrVectorValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: (value2 isIntegerOrVectorValue).
    self assert: (name isSingleByteString).
    ^LLVM BuildAShr: self  _: value1 _: value2 _: name

    "Created: / 11-07-2015 / 16:46:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

lshr:value1 by:value2 
    ^ self lshr:value1 by: value2 as:''

    "Created: / 11-07-2015 / 13:02:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

lshr:value1 by:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value1 isIntegerOrVectorValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: (value2 isIntegerOrVectorValue).
    self assert: (name isSingleByteString).
    ^LLVM BuildLShr: self  _: value1 _: value2 _: name

    "Created: / 11-07-2015 / 14:49:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

or:value1 and:value2 
    ^ self or:value1 and:value2 as:''

    "Created: / 11-07-2015 / 17:17:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

or:value1 and:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value1 isIntegerOrVectorValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: (value2 isIntegerOrVectorValue).
    self assert: (name isSingleByteString).
    ^LLVM BuildOr: self  _: value1 _: value2 _: name

    "Created: / 11-07-2015 / 17:16:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

shl:value1 by:value2 
    ^ self shl:value1 by: value2 as:''

    "Created: / 11-07-2015 / 16:37:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

shl:value1 by:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value1 isIntegerOrVectorValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: (value2 isIntegerOrVectorValue).
    self assert: (name isSingleByteString).
    ^LLVM BuildShl: self  _: value1 _: value2 _: name

    "Created: / 11-07-2015 / 16:37:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'instructions - other'!

call: function with: arg1
    ^ self call: function withArguments: (Array with: arg1) as: ''.

    "Created: / 17-07-2015 / 12:48:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

call: function with: arg1 with: arg2
    ^ self call: function withArguments: (Array with: arg1 with: arg2) as: ''.

    "Created: / 17-07-2015 / 12:48:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

call: function with: arg1 with: arg2 with: arg3
    ^ self call: function withArguments: (Array with: arg1 with: arg2 with: arg3) as: ''.

    "Created: / 17-07-2015 / 12:48:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

call: function withArguments: arguments
    ^ self call: function withArguments: arguments as: ''.

    "Created: / 17-07-2015 / 12:47:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

call: function withArguments: arguments as: name
    | argumentsArray argumentsSize |

    self assert: (function isKindOf: LLVMFunction).
    self assert: (arguments isCollection).
    arguments do:[:argument | 
        self assert: (argument isKindOf:LLVMValue).  
    ].
    self assert: name isSingleByteString.

    argumentsSize := arguments size.
    argumentsArray := arguments asLLVMObjectArray.
    ^ LLVM BuildCall: self _: function _: argumentsArray _: argumentsSize _: name

    "Created: / 17-07-2015 / 11:09:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

gep: pointer at: integerOrArrayOfIntegers
    ^ self gep: pointer at: integerOrArrayOfIntegers as: ''

    "Created: / 05-08-2015 / 20:58:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

gep: pointer at: integerOrArrayOfIntegers as: name
    | indices |

    self assert: (pointer isKindOf: LLVMValue).
    self assert: (integerOrArrayOfIntegers isInteger 
                    or:[ integerOrArrayOfIntegers isSequenceable and:[ integerOrArrayOfIntegers allSatisfy:[:e|e isInteger] ] ]).
    self assert: (name isSingleByteString).    
    integerOrArrayOfIntegers isInteger ifTrue:[ 
        indices := LLVMObjectArray with: (LLVMConstant uint32: integerOrArrayOfIntegers)
    ] ifFalse:[ 
        indices := LLVMObjectArray new: integerOrArrayOfIntegers size.
        1 to: indices size do:[:i |
            indices at: i put: (LLVMConstant uint32: (integerOrArrayOfIntegers at: i)).
        ].
    ].
    ^ LLVM BuildGEP: self _: pointer _: indices _: indices size _: name.

    "Created: / 05-08-2015 / 20:58:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'instructions - terminators'!

ret:value1 
    self assert: (value1 isKindOf: LLVMValue).
    ^ LLVM BuildRet: self _: value1

    "Created: / 07-07-2015 / 22:55:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'positioning'!

positionAtEnd: basicBlock
    LLVM PositionBuilderAtEnd: self  _: basicBlock

    "Created: / 07-07-2015 / 22:45:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

